#-----------------------------------------------------------------------------
# Quickie: follow the leader
# by Ockham 12/26/09
# occam24@aol.com
from Tkinter import *
import poser
scene = poser.Scene()
try:
	Fig=scene.CurrentFigure()
except:
	raise "No figure."

#-----------------------------------------------------------------------------

class App:
	def __init__(self, master, textMessage):
		self.master = master
		self.ListBefore={}
		master.title("All follow the leader")

		self.buttonStart = Button(self.master, text="Start", command=self.HandleStart)
		self.buttonStart.grid(row=1, column=0,pady=4,padx=4)
		self.buttonFollow = Button(self.master, text="Follow", command=self.HandleFollow)
		self.buttonFollow.grid(row=1, column=1,pady=4,padx=4)


		self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)

	# - - - - - - - - - - - - - - - - - -

	def HandleStart(self):
		# Check the main, fill in Before
		B=Fig.Actor("BODY")
		for P in B.Parameters():
			self.ListBefore[P.Name()]=P.Value()

	# - - - - - - - - - - - - - - - - - -

	def HandleFollow(self):
		# Check the main again.  If anything differs, set other figs.
		B=Fig.Actor("BODY")
		for P in B.Parameters():
			# Hold the before stuff
			OldValue=self.ListBefore[P.Name()]
			OldName=P.Name()
			if P.Value()!= OldValue:
				# Change the list to the new value
				NewValue=P.Value()
				self.ListBefore[OldName]=NewValue
				# Change others to this new value
				for subF in scene.Figures():
					if subF == Fig: continue
					subF.Actor("BODY").Parameter(OldName).SetValue(NewValue)

	# - - - - - - - - - - - - - - - - - -

	def Update(self):
		if scene: scene.ProcessSomeEvents()
		root.lift()
		root.after(100, self.Update)

	# - - - - - - - - - - - - - - - - - -

	def HandleCancel(self):
		self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
